<?

if (file_exists("db/blocked_ips.txt.php")) {
	$block=file("db/blocked_ips.txt.php");
} else {
	$block[]="";
}

// loose checking, include ranges like 127.128.129.* or 127.128.129.40-80
function ip_same($num1, $num2) {

	if ($num1==$num2) { return TRUE; }
	if ( ($num1=="*") || ($num2=="*") ) { return TRUE; }
	if ( strpos($num2,"-") > 0 ) {
		list($num2_min, $num2_max) = explode("-", $num2);
		if ( ($num1>=$num2_min) && ($num1<=$num2_max) ) { return TRUE; }
	}

	return FALSE;

}

function ip_check_block($ip) {
	global $block;

	$ip=explode(".", $ip);

	foreach ($block as $test_ip) {
		$test_ip=trim($test_ip);
		$test_ip=explode(".", $test_ip);
		
		if ( (ip_same($ip[0], $test_ip[0])) && (ip_same($ip[1], $test_ip[1])) && (ip_same($ip[2], $test_ip[2])) && (ip_same($ip[3], $test_ip[3])) ) {
			return TRUE;
		}

	}
	return FALSE;

}

// strict checking. no ranges.
function ip_check_block_strict($ip) {
	global $block;

	foreach ($block as $test_ip) {
		if ($ip==trim($test_ip)) {
			return TRUE;
		}
	}
	
	return FALSE;
}



function block_type($ip){

	if (!(ip_check_block($ip))) {
		return "none";
	} else {
		if (ip_check_block_strict($ip)) {
			return "single";
		} else {
			return "range";
		}
	}
}


function add_block($ip) {

	$fp=fopen("db/blocked_ips.txt.php", "a");
	fwrite($fp, $ip."\n");
	fclose($fp);
}


function rem_block($ip) {
	global $block;

	$fp=fopen("db/blocked_ips.txt.php", "w");
	foreach ($block as $line) {
		if (trim($line) != $ip) {
			fwrite($fp, trim($line)."\n");
		}
	}
	fclose($fp);
}

function make_mask($ip) {

	$ip=explode(".",$ip);
	$ip['3']="*";
	$ip=implode(".",$ip);
	
	return $ip;

}

?>